PVideoOutputDevice Class Referenceabstract

This class defines a video output device. More...

`#include <videoio.h>`

Inheritance diagram for PVideoOutputDevice:

## Public Member Functions

| PVideoOutputDevice ()
| Create a new video output device. More...
virtual | ~PVideoOutputDevice ()
| Close the video output device on destruction. More...
virtual PBoolean | Close ()
| Close the device. More...
virtual PBoolean | Start ()
| Start the video device I/O display. More...
virtual PBoolean | Stop ()
| Stop the video device I/O display. More...
virtual PBoolean | CanCaptureVideo () const
| Is the device a camera, and obtain video. More...
virtual PBoolean | SetFrameData (unsigned x, unsigned y, unsigned width, unsigned height, const BYTE *data, PBoolean endFrame=true)=0
| Set a section of the output frame buffer. More...
virtual PBoolean | SetFrameData (unsigned x, unsigned y, unsigned width, unsigned height, const BYTE *data, PBoolean endFrame, unsigned flags)
virtual PBoolean | SetFrameData (unsigned x, unsigned y, unsigned width, unsigned height, unsigned sarwidth, unsigned sarheight, const BYTE *data, PBoolean endFrame, unsigned flags, const void *mark)
virtual PBoolean | DisableDecode ()
| Allow the outputdevice decide whether the decoder should ignore decode hence not render any output. More...
virtual PBoolean | GetPosition (int &x, int &y) const
| Get the position of the output device, where relevant. More...
virtual bool | SetPosition (int x, int y)
| Set the position of the output device, where relevant. More...
Public Member Functions inherited from PVideoDevice
virtual | ~PVideoDevice ()
| Delete structures created by PVideoDevice();. More...
const PString & | GetDeviceName () const
| Get the device name of the open device. More...
virtual PStringArray | GetDeviceNames () const =0
| Get a list of all of the drivers available. More...
virtual PBoolean | OpenFull (const OpenArgs &args, PBoolean startImmediate=true)
| Open the device given the device name. More...
virtual PBoolean | Open (const PString &deviceName, PBoolean startImmediate=true)=0
| Open the device given the device name. More...
virtual PBoolean | IsOpen ()=0
| Determine if the device is currently open. More...
virtual PBoolean | SetVideoFormat (VideoFormat videoFormat)
| Set the video format to be used. More...
virtual VideoFormat | GetVideoFormat () const
| Get the video format being used. More...
virtual int | GetNumChannels ()
| Get the number of video channels available on the device. More...
virtual PBoolean | SetChannel (int channelNumber)
| Set the video channel to be used on the device. More...
virtual int | GetChannel () const
| Get the video channel to be used on the device. More...
virtual PBoolean | SetColourFormatConverter (const PString &colourFormat)
| Set the colour format to be used, trying converters if available. More...
virtual PBoolean | GetVFlipState ()
| Get the video conversion vertical flip state. More...
virtual PBoolean | SetVFlipState (PBoolean newVFlipState)
| Set the video conversion vertical flip state. More...
virtual PBoolean | GetFrameSizeLimits (unsigned &minWidth, unsigned &minHeight, unsigned &maxWidth, unsigned &maxHeight)
| Get the minimum & maximum size of a frame on the device. More...
virtual PBoolean | SetFrameSizeConverter (unsigned width, unsigned height, ResizeMode resizeMode=eMaxResizeMode)
| Set the frame size to be used, trying converters if available. More...
virtual PBoolean | SetFrameSizeConverter (unsigned width, unsigned height, PBoolean)
| Set the frame size to be used, trying converters if available. More...
virtual PBoolean | SetNearestFrameSize (unsigned width, unsigned height)
| Set the nearest available frame size to be used. More...
virtual PBoolean | SetFrameSize (unsigned width, unsigned height)
| Set the frame size to be used. More...
virtual PBoolean | GetFrameSize (unsigned &width, unsigned &height) const
| Get the frame size being used. More...
virtual PINDEX | GetMaxFrameBytes ()=0
| Get the maximum frame size in bytes. More...
int | GetLastError () const
| Get the last error code. More...
virtual int | GetBrightness ()
| Get the brightness of the image. More...
virtual PBoolean | SetBrightness (unsigned newBrightness)
| Set brightness of the image. More...
virtual int | GetWhiteness ()
| Get the whiteness of the image. More...
virtual PBoolean | SetWhiteness (unsigned newWhiteness)
| Set whiteness of the image. More...
virtual int | GetColour ()
| Get the colour of the image. More...
virtual PBoolean | SetColour (unsigned newColour)
| Set colour of the image. More...
virtual int | GetContrast ()
| Get the contrast of the image. More...
virtual PBoolean | SetContrast (unsigned newContrast)
| Set contrast of the image. More...
virtual int | GetHue ()
| Get the hue of the image. More...
virtual PBoolean | SetHue (unsigned newHue)
| Set hue of the image. More...
virtual PBoolean | GetParameters (int *whiteness, int *brightness, int *colour, int *contrast, int *hue)
| Return whiteness, brightness, colour, contrast and hue in one call. More...
virtual PBoolean | SetVideoChannelFormat (int channelNumber, VideoFormat videoFormat)
| Set VideoFormat and VideoChannel in one ioctl. More...
void | SetPreferredColourFormat (const PString &colourFmt)
| Set preferred native colour format from video capture device. More...
const PString & | GetPreferredColourFormat ()
| Get preferred native colour format from video capture device. More...
Public Member Functions inherited from PVideoFrameInfo
| PVideoFrameInfo ()
| Construct video frame information. More...
| PVideoFrameInfo (unsigned frameWidth, unsigned frameHeight, const PString &colourFormat="YUV420P", unsigned frameRate=15, ResizeMode resizeMode=eScale)
virtual Comparison | Compare (const PObject &obj) const
| Compare the two PVideoFrameInfo and return their relative rank. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual unsigned | GetFrameWidth () const
| Get the width of the frame being used. More...
virtual unsigned | GetFrameHeight () const
| Get the height of the frame being used. More...
virtual PBoolean | SetFrameSar (unsigned width, unsigned height)
| Set the sar size to be used. More...
virtual PBoolean | GetSarSize (unsigned &width, unsigned &height) const
| Get the sar size being used. More...
virtual unsigned | GetSarWidth () const
| Get the width of the sar being used. More...
virtual unsigned | GetSarHeight () const
| Get the height of the sar being used. More...
virtual PBoolean | SetFrameRate (unsigned rate)
| Set the video frame rate to be used on the device. More...
virtual unsigned | GetFrameRate () const
| Get the video frame rate used on the device. More...
virtual PBoolean | SetColourFormat (const PString &colourFormat)
| Set the colour format to be used. More...
virtual const PString & | GetColourFormat () const
| Get the colour format to be used. More...
void | SetResizeMode (ResizeMode mode)
| Set the resize mode to be used. More...
ResizeMode | GetResizeMode () const
| Get the resize mode to be used. More...
PINDEX | CalculateFrameBytes () const
| Get the number of bytes of an image, given a particular width, height and colour format. More...
bool | Parse (const PString &str)
| Parse a descriptor string for the video format. More...
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Static Public Member Functions

static PStringArray | GetDriverNames (PPluginManager *pluginMgr=NULL)
| Get the list of available video output drivers (plug-ins) More...
static PStringArray | GetDriversDeviceNames (const PString &driverName, PPluginManager *pluginMgr=NULL)
| Get video output devices that correspond to the specified driver name. More...
static PVideoOutputDevice * | CreateDevice (const PString &driverName, PPluginManager *pluginMgr=NULL)
| Create the video output device that corresponds to the specified driver name. More...
static PVideoOutputDevice * | CreateDeviceByName (const PString &deviceName, const PString &driverName=PString::Empty(), PPluginManager *pluginMgr=NULL)
static PVideoOutputDevice * | CreateOpenedDevice (const PString &driverName, const PString &deviceName, PBoolean startImmediate=true, PPluginManager *pluginMgr=NULL)
| Create an opened video output device that corresponds to the specified names. More...
static PVideoOutputDevice * | CreateOpenedDevice (const OpenArgs &args, PBoolean startImmediate=true)
| Create an opened video output device that corresponds to the specified arguments. More...
Static Public Member Functions inherited from PVideoFrameInfo
static PINDEX | CalculateFrameBytes (unsigned width, unsigned height, const PString &colourFormat)
static bool | ParseSize (const PString &str, unsigned &width, unsigned &height)
| Parse the standard size string names. More...
static PString | AsString (unsigned width, unsigned height)
| Get a width/height as a standard size string name. More...
static PStringArray | GetSizeNames ()
| Get all "known" image size names. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...

## Additional Inherited Members

Public Types inherited from PVideoDevice
enum | VideoFormat { PAL, NTSC, SECAM, Auto, NumVideoFormats }
Public Types inherited from PVideoFrameInfo
enum | ResizeMode { eScale, eCropCentre, eCropTopLeft, eMaxResizeMode }

enum

StandardSizes {
SQCIFWidth = 128, SQCIFHeight = 96, QCIFWidth = 176, QCIFHeight = 144,
CIFWidth = 352, CIFHeight = 288, CIF4Width = 704, CIF4Height = 576,
CIF16Width = 1408, CIF16Height = 1152, HD480Width = 704, HD480Height = 480,
i480Width = 704, i480Height = 480, HD720Width = 1280, HD720Height = 720,
p720Width = 1280, p720Height = 720, HD1080Width = 1920, HD1080Height = 1080,
i1080Width = 1920, i1080Height = 1080, HDTVWidth = 1920, HDTVHeight = 1080,
MaxWidth = 1920, MaxHeight = 1200
}

Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Protected Member Functions inherited from PVideoDevice
| PVideoDevice ()
| Create a new video device (input or output). More...
PINDEX | GetMaxFrameBytesConverted (PINDEX rawFrameBytes) const
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PVideoDevice
PString | deviceName
int | lastError
VideoFormat | videoFormat
int | channelNumber
PString | preferredColourFormat
PBoolean | nativeVerticalFlip
PColourConverter * | converter
PBYTEArray | frameStore
int | frameBrightness
int | frameWhiteness
int | frameContrast
int | frameColour
int | frameHue
Protected Attributes inherited from PVideoFrameInfo
unsigned | frameWidth
unsigned | frameHeight
unsigned | sarWidth
unsigned | sarHeight
unsigned | frameRate
PString | colourFormat
ResizeMode | resizeMode

## Detailed Description

This class defines a video output device.

- typically, a window.

## Constructor & Destructor Documentation

PVideoOutputDevice::PVideoOutputDevice | ( |  | ) |

Create a new video output device.

virtual PVideoOutputDevice::~PVideoOutputDevice | ( |  | ) |

inline virtual

Close the video output device on destruction.

References Close().

## Member Function Documentation

virtual PBoolean PVideoOutputDevice::CanCaptureVideo | ( |  | ) | const

virtual

Is the device a camera, and obtain video.

Implements PVideoDevice.

virtual PBoolean PVideoOutputDevice::Close | ( |  | ) |

inline virtual

Close the device.

Implements PVideoDevice.

Referenced by ~PVideoOutputDevice().

static PVideoOutputDevice* PVideoOutputDevice::CreateDevice | ( | const PString & | driverName,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

Create the video output device that corresponds to the specified driver name.

Parameters

  driverName | Name of driver
  pluginMgr | Plug in manager, use default if NULL

static PVideoOutputDevice* PVideoOutputDevice::CreateDeviceByName | ( | const PString & | deviceName,
|  | const PString & | driverName = `PString::Empty()`,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

Parameters

  deviceName | Name of device
  driverName | Name of driver (if any)
  pluginMgr | Plug in manager, use default if NULL

static PVideoOutputDevice* PVideoOutputDevice::CreateOpenedDevice | ( | const PString & | driverName,
|  | const PString & | deviceName,
|  | PBoolean | startImmediate = `true`,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

Create an opened video output device that corresponds to the specified names.

If the driverName parameter is an empty string or "*" then CreateDeviceByName is used with the deviceName parameter which is assumed to be a value returned from GetDriversDeviceNames().

Parameters

  driverName | Name of driver
  deviceName | Name of device
  startImmediate | Immediately start display
  pluginMgr | Plug in manager, use default if NULL

static PVideoOutputDevice* PVideoOutputDevice::CreateOpenedDevice | ( | const OpenArgs & | args,
|  | PBoolean | startImmediate = `true`
| ) |  |

static

Create an opened video output device that corresponds to the specified arguments.

Parameters

  args | Parameters to set on opened device
  startImmediate | Immediately start display

virtual PBoolean PVideoOutputDevice::DisableDecode | ( |  | ) |

virtual

Allow the outputdevice decide whether the decoder should ignore decode hence not render any output.

Returns: false if to decode and render.

static PStringArray PVideoOutputDevice::GetDriverNames | ( | PPluginManager * | pluginMgr = `NULL` | ) |

static

Get the list of available video output drivers (plug-ins)

Parameters

  pluginMgr | Plug in manager, use default if NULL

static PStringArray PVideoOutputDevice::GetDriversDeviceNames | ( | const PString & | driverName,
|  | PPluginManager * | pluginMgr = `NULL`
| ) |  |

static

Get video output devices that correspond to the specified driver name.

If driverName is an empty string or the value "*" then this will return a list of unique device names across all of the available drivers. If two drivers have identical names for devices, then the string returned will be of the form driver+'\t'+device.

Parameters

  driverName | Name of driver
  pluginMgr | Plug in manager, use default if NULL

virtual PBoolean PVideoOutputDevice::GetPosition | ( | int & | x,
|  | int & | y
| ) |  | const

virtual

Get the position of the output device, where relevant.

For devices such as files, this always returns zeros. For devices such as Windows, this is the position of the window on the screen.

Returns: TRUE if the position is available.

virtual PBoolean PVideoOutputDevice::SetFrameData | ( | unsigned | x,
|  | unsigned | y,
|  | unsigned | width,
|  | unsigned | height,
|  | const BYTE * | data,
|  | PBoolean | endFrame = `true`
| ) |  |

pure virtual

Set a section of the output frame buffer.

Implemented in PVideoOutputDeviceRGB.

virtual PBoolean PVideoOutputDevice::SetFrameData | ( | unsigned | x,
|  | unsigned | y,
|  | unsigned | width,
|  | unsigned | height,
|  | const BYTE * | data,
|  | PBoolean | endFrame,
|  | unsigned | flags
| ) |  |

virtual

virtual PBoolean PVideoOutputDevice::SetFrameData | ( | unsigned | x,
|  | unsigned | y,
|  | unsigned | width,
|  | unsigned | height,
|  | unsigned | sarwidth,
|  | unsigned | sarheight,
|  | const BYTE * | data,
|  | PBoolean | endFrame,
|  | unsigned | flags,
|  | const void * | mark
| ) |  |

virtual

virtual bool PVideoOutputDevice::SetPosition | ( | int | x,
|  | int | y
| ) |  |

virtual

Set the position of the output device, where relevant.

For devices such as files, this does nothing. For devices such as Windows, this sets the position of the window on the screen.

Returns: TRUE if the position can be set.

virtual PBoolean PVideoOutputDevice::Start | ( |  | ) |

inline virtual

Start the video device I/O display.

Implements PVideoDevice.

virtual PBoolean PVideoOutputDevice::Stop | ( |  | ) |

inline virtual

Stop the video device I/O display.

Implements PVideoDevice.

The documentation for this class was generated from the following file:

- videoio.h